"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateGetComplianceSummary = void 0;
const GetComplianceSummaryCommand_1 = require("../commands/GetComplianceSummaryCommand");
const ResourceGroupsTaggingAPI_1 = require("../ResourceGroupsTaggingAPI");
const ResourceGroupsTaggingAPIClient_1 = require("../ResourceGroupsTaggingAPIClient");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new GetComplianceSummaryCommand_1.GetComplianceSummaryCommand(input), ...args);
};
const makePagedRequest = async (client, input, ...args) => {
    return await client.getComplianceSummary(input, ...args);
};
async function* paginateGetComplianceSummary(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.PaginationToken = token;
        input["MaxResults"] = config.pageSize;
        if (config.client instanceof ResourceGroupsTaggingAPI_1.ResourceGroupsTaggingAPI) {
            page = await makePagedRequest(config.client, input, ...additionalArguments);
        }
        else if (config.client instanceof ResourceGroupsTaggingAPIClient_1.ResourceGroupsTaggingAPIClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected ResourceGroupsTaggingAPI | ResourceGroupsTaggingAPIClient");
        }
        yield page;
        const prevToken = token;
        token = page.PaginationToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateGetComplianceSummary = paginateGetComplianceSummary;
