import { resolveEndpointsConfig, resolveRegionConfig, } from "@trivikr-test/config-resolver";
import { getContentLengthPlugin } from "@trivikr-test/middleware-content-length";
import { getHostHeaderPlugin, resolveHostHeaderConfig, } from "@trivikr-test/middleware-host-header";
import { getLoggerPlugin } from "@trivikr-test/middleware-logger";
import { getRecursionDetectionPlugin } from "@trivikr-test/middleware-recursion-detection";
import { getRetryPlugin, resolveRetryConfig } from "@trivikr-test/middleware-retry";
import { getAwsAuthPlugin, resolveAwsAuthConfig, } from "@trivikr-test/middleware-signing";
import { getUserAgentPlugin, resolveUserAgentConfig, } from "@trivikr-test/middleware-user-agent";
import { Client as __Client, } from "@trivikr-test/smithy-client";
import { getRuntimeConfig as __getRuntimeConfig } from "./runtimeConfig";
export class ResourceGroupsTaggingAPIClient extends __Client {
    constructor(configuration) {
        const _config_0 = __getRuntimeConfig(configuration);
        const _config_1 = resolveRegionConfig(_config_0);
        const _config_2 = resolveEndpointsConfig(_config_1);
        const _config_3 = resolveRetryConfig(_config_2);
        const _config_4 = resolveHostHeaderConfig(_config_3);
        const _config_5 = resolveAwsAuthConfig(_config_4);
        const _config_6 = resolveUserAgentConfig(_config_5);
        super(_config_6);
        this.config = _config_6;
        this.middlewareStack.use(getRetryPlugin(this.config));
        this.middlewareStack.use(getContentLengthPlugin(this.config));
        this.middlewareStack.use(getHostHeaderPlugin(this.config));
        this.middlewareStack.use(getLoggerPlugin(this.config));
        this.middlewareStack.use(getRecursionDetectionPlugin(this.config));
        this.middlewareStack.use(getAwsAuthPlugin(this.config));
        this.middlewareStack.use(getUserAgentPlugin(this.config));
    }
    destroy() {
        super.destroy();
    }
}
