import { getSerdePlugin } from "@trivikr-test/middleware-serde";
import { Command as $Command } from "@trivikr-test/smithy-client";
import { GetTagValuesInputFilterSensitiveLog, GetTagValuesOutputFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_json1_1GetTagValuesCommand, serializeAws_json1_1GetTagValuesCommand, } from "../protocols/Aws_json1_1";
export class GetTagValuesCommand extends $Command {
    constructor(input) {
        super();
        this.input = input;
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "ResourceGroupsTaggingAPIClient";
        const commandName = "GetTagValuesCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: GetTagValuesInputFilterSensitiveLog,
            outputFilterSensitiveLog: GetTagValuesOutputFilterSensitiveLog,
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return serializeAws_json1_1GetTagValuesCommand(input, context);
    }
    deserialize(output, context) {
        return deserializeAws_json1_1GetTagValuesCommand(output, context);
    }
}
