import { ResourceGroupsTaggingAPIServiceException as __BaseException } from "./ResourceGroupsTaggingAPIServiceException";
export class ConcurrentModificationException extends __BaseException {
    constructor(opts) {
        super({
            name: "ConcurrentModificationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConcurrentModificationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConcurrentModificationException.prototype);
        this.Message = opts.Message;
    }
}
export class ConstraintViolationException extends __BaseException {
    constructor(opts) {
        super({
            name: "ConstraintViolationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConstraintViolationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConstraintViolationException.prototype);
        this.Message = opts.Message;
    }
}
export class InternalServiceException extends __BaseException {
    constructor(opts) {
        super({
            name: "InternalServiceException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServiceException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServiceException.prototype);
        this.Message = opts.Message;
    }
}
export class InvalidParameterException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidParameterException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidParameterException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidParameterException.prototype);
        this.Message = opts.Message;
    }
}
export class ThrottledException extends __BaseException {
    constructor(opts) {
        super({
            name: "ThrottledException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottledException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottledException.prototype);
        this.Message = opts.Message;
    }
}
export var ErrorCode;
(function (ErrorCode) {
    ErrorCode["INTERNAL_SERVICE_EXCEPTION"] = "InternalServiceException";
    ErrorCode["INVALID_PARAMETER_EXCEPTION"] = "InvalidParameterException";
})(ErrorCode || (ErrorCode = {}));
export var GroupByAttribute;
(function (GroupByAttribute) {
    GroupByAttribute["REGION"] = "REGION";
    GroupByAttribute["RESOURCE_TYPE"] = "RESOURCE_TYPE";
    GroupByAttribute["TARGET_ID"] = "TARGET_ID";
})(GroupByAttribute || (GroupByAttribute = {}));
export var TargetIdType;
(function (TargetIdType) {
    TargetIdType["ACCOUNT"] = "ACCOUNT";
    TargetIdType["OU"] = "OU";
    TargetIdType["ROOT"] = "ROOT";
})(TargetIdType || (TargetIdType = {}));
export class PaginationTokenExpiredException extends __BaseException {
    constructor(opts) {
        super({
            name: "PaginationTokenExpiredException",
            $fault: "client",
            ...opts,
        });
        this.name = "PaginationTokenExpiredException";
        this.$fault = "client";
        Object.setPrototypeOf(this, PaginationTokenExpiredException.prototype);
        this.Message = opts.Message;
    }
}
export const ComplianceDetailsFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeReportCreationInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeReportCreationOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const FailureInfoFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetComplianceSummaryInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const SummaryFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetComplianceSummaryOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagFilterFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetResourcesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ResourceTagMappingFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetResourcesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetTagKeysInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetTagKeysOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetTagValuesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetTagValuesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StartReportCreationInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StartReportCreationOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagResourcesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagResourcesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const UntagResourcesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const UntagResourcesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
