import { GetComplianceSummaryCommand, } from "../commands/GetComplianceSummaryCommand";
import { ResourceGroupsTaggingAPI } from "../ResourceGroupsTaggingAPI";
import { ResourceGroupsTaggingAPIClient } from "../ResourceGroupsTaggingAPIClient";
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new GetComplianceSummaryCommand(input), ...args);
};
const makePagedRequest = async (client, input, ...args) => {
    return await client.getComplianceSummary(input, ...args);
};
export async function* paginateGetComplianceSummary(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.PaginationToken = token;
        input["MaxResults"] = config.pageSize;
        if (config.client instanceof ResourceGroupsTaggingAPI) {
            page = await makePagedRequest(config.client, input, ...additionalArguments);
        }
        else if (config.client instanceof ResourceGroupsTaggingAPIClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected ResourceGroupsTaggingAPI | ResourceGroupsTaggingAPIClient");
        }
        yield page;
        const prevToken = token;
        token = page.PaginationToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
