import { HttpRequest as __HttpRequest } from "@trivikr-test/protocol-http";
import { decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectInt32 as __expectInt32, expectLong as __expectLong, expectString as __expectString, throwDefaultError, } from "@trivikr-test/smithy-client";
import { ConcurrentModificationException, ConstraintViolationException, InternalServiceException, InvalidParameterException, PaginationTokenExpiredException, ThrottledException, } from "../models/models_0";
import { ResourceGroupsTaggingAPIServiceException as __BaseException } from "../models/ResourceGroupsTaggingAPIServiceException";
export const serializeAws_json1_1DescribeReportCreationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.DescribeReportCreation",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1DescribeReportCreationInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetComplianceSummaryCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.GetComplianceSummary",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetComplianceSummaryInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetResourcesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.GetResources",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetResourcesInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetTagKeysCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.GetTagKeys",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetTagKeysInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1GetTagValuesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.GetTagValues",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1GetTagValuesInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1StartReportCreationCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.StartReportCreation",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1StartReportCreationInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1TagResourcesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.TagResources",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1TagResourcesInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const serializeAws_json1_1UntagResourcesCommand = async (input, context) => {
    const headers = {
        "content-type": "application/x-amz-json-1.1",
        "x-amz-target": "ResourceGroupsTaggingAPI_20170126.UntagResources",
    };
    let body;
    body = JSON.stringify(serializeAws_json1_1UntagResourcesInput(input, context));
    return buildHttpRpcRequest(context, headers, "/", undefined, body);
};
export const deserializeAws_json1_1DescribeReportCreationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1DescribeReportCreationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1DescribeReportCreationOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1DescribeReportCreationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ConstraintViolationException":
        case "com.amazonaws.resourcegroupstaggingapi#ConstraintViolationException":
            throw await deserializeAws_json1_1ConstraintViolationExceptionResponse(parsedOutput, context);
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetComplianceSummaryCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetComplianceSummaryCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetComplianceSummaryOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetComplianceSummaryCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ConstraintViolationException":
        case "com.amazonaws.resourcegroupstaggingapi#ConstraintViolationException":
            throw await deserializeAws_json1_1ConstraintViolationExceptionResponse(parsedOutput, context);
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetResourcesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetResourcesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetResourcesOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetResourcesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "PaginationTokenExpiredException":
        case "com.amazonaws.resourcegroupstaggingapi#PaginationTokenExpiredException":
            throw await deserializeAws_json1_1PaginationTokenExpiredExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetTagKeysCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetTagKeysCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetTagKeysOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetTagKeysCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "PaginationTokenExpiredException":
        case "com.amazonaws.resourcegroupstaggingapi#PaginationTokenExpiredException":
            throw await deserializeAws_json1_1PaginationTokenExpiredExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1GetTagValuesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1GetTagValuesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1GetTagValuesOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1GetTagValuesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "PaginationTokenExpiredException":
        case "com.amazonaws.resourcegroupstaggingapi#PaginationTokenExpiredException":
            throw await deserializeAws_json1_1PaginationTokenExpiredExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1StartReportCreationCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1StartReportCreationCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1StartReportCreationOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1StartReportCreationCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "ConcurrentModificationException":
        case "com.amazonaws.resourcegroupstaggingapi#ConcurrentModificationException":
            throw await deserializeAws_json1_1ConcurrentModificationExceptionResponse(parsedOutput, context);
        case "ConstraintViolationException":
        case "com.amazonaws.resourcegroupstaggingapi#ConstraintViolationException":
            throw await deserializeAws_json1_1ConstraintViolationExceptionResponse(parsedOutput, context);
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1TagResourcesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1TagResourcesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1TagResourcesOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1TagResourcesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
export const deserializeAws_json1_1UntagResourcesCommand = async (output, context) => {
    if (output.statusCode >= 300) {
        return deserializeAws_json1_1UntagResourcesCommandError(output, context);
    }
    const data = await parseBody(output.body, context);
    let contents = {};
    contents = deserializeAws_json1_1UntagResourcesOutput(data, context);
    const response = {
        $metadata: deserializeMetadata(output),
        ...contents,
    };
    return Promise.resolve(response);
};
const deserializeAws_json1_1UntagResourcesCommandError = async (output, context) => {
    const parsedOutput = {
        ...output,
        body: await parseBody(output.body, context),
    };
    const errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
    switch (errorCode) {
        case "InternalServiceException":
        case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
            throw await deserializeAws_json1_1InternalServiceExceptionResponse(parsedOutput, context);
        case "InvalidParameterException":
        case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
            throw await deserializeAws_json1_1InvalidParameterExceptionResponse(parsedOutput, context);
        case "ThrottledException":
        case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
            throw await deserializeAws_json1_1ThrottledExceptionResponse(parsedOutput, context);
        default:
            const parsedBody = parsedOutput.body;
            throwDefaultError({
                output,
                parsedBody,
                exceptionCtor: __BaseException,
                errorCode,
            });
    }
};
const deserializeAws_json1_1ConcurrentModificationExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ConcurrentModificationException(body, context);
    const exception = new ConcurrentModificationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1ConstraintViolationExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ConstraintViolationException(body, context);
    const exception = new ConstraintViolationException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1InternalServiceExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InternalServiceException(body, context);
    const exception = new InternalServiceException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1InvalidParameterExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1InvalidParameterException(body, context);
    const exception = new InvalidParameterException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1PaginationTokenExpiredExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1PaginationTokenExpiredException(body, context);
    const exception = new PaginationTokenExpiredException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const deserializeAws_json1_1ThrottledExceptionResponse = async (parsedOutput, context) => {
    const body = parsedOutput.body;
    const deserialized = deserializeAws_json1_1ThrottledException(body, context);
    const exception = new ThrottledException({
        $metadata: deserializeMetadata(parsedOutput),
        ...deserialized,
    });
    return __decorateServiceException(exception, body);
};
const serializeAws_json1_1DescribeReportCreationInput = (input, context) => {
    return {};
};
const serializeAws_json1_1GetComplianceSummaryInput = (input, context) => {
    return {
        ...(input.GroupBy != null && { GroupBy: serializeAws_json1_1GroupBy(input.GroupBy, context) }),
        ...(input.MaxResults != null && { MaxResults: input.MaxResults }),
        ...(input.PaginationToken != null && { PaginationToken: input.PaginationToken }),
        ...(input.RegionFilters != null && {
            RegionFilters: serializeAws_json1_1RegionFilterList(input.RegionFilters, context),
        }),
        ...(input.ResourceTypeFilters != null && {
            ResourceTypeFilters: serializeAws_json1_1ResourceTypeFilterList(input.ResourceTypeFilters, context),
        }),
        ...(input.TagKeyFilters != null && {
            TagKeyFilters: serializeAws_json1_1TagKeyFilterList(input.TagKeyFilters, context),
        }),
        ...(input.TargetIdFilters != null && {
            TargetIdFilters: serializeAws_json1_1TargetIdFilterList(input.TargetIdFilters, context),
        }),
    };
};
const serializeAws_json1_1GetResourcesInput = (input, context) => {
    return {
        ...(input.ExcludeCompliantResources != null && { ExcludeCompliantResources: input.ExcludeCompliantResources }),
        ...(input.IncludeComplianceDetails != null && { IncludeComplianceDetails: input.IncludeComplianceDetails }),
        ...(input.PaginationToken != null && { PaginationToken: input.PaginationToken }),
        ...(input.ResourceARNList != null && {
            ResourceARNList: serializeAws_json1_1ResourceARNListForGet(input.ResourceARNList, context),
        }),
        ...(input.ResourceTypeFilters != null && {
            ResourceTypeFilters: serializeAws_json1_1ResourceTypeFilterList(input.ResourceTypeFilters, context),
        }),
        ...(input.ResourcesPerPage != null && { ResourcesPerPage: input.ResourcesPerPage }),
        ...(input.TagFilters != null && { TagFilters: serializeAws_json1_1TagFilterList(input.TagFilters, context) }),
        ...(input.TagsPerPage != null && { TagsPerPage: input.TagsPerPage }),
    };
};
const serializeAws_json1_1GetTagKeysInput = (input, context) => {
    return {
        ...(input.PaginationToken != null && { PaginationToken: input.PaginationToken }),
    };
};
const serializeAws_json1_1GetTagValuesInput = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.PaginationToken != null && { PaginationToken: input.PaginationToken }),
    };
};
const serializeAws_json1_1GroupBy = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1RegionFilterList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ResourceARNListForGet = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ResourceARNListForTagUntag = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1ResourceTypeFilterList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1StartReportCreationInput = (input, context) => {
    return {
        ...(input.S3Bucket != null && { S3Bucket: input.S3Bucket }),
    };
};
const serializeAws_json1_1TagFilter = (input, context) => {
    return {
        ...(input.Key != null && { Key: input.Key }),
        ...(input.Values != null && { Values: serializeAws_json1_1TagValueList(input.Values, context) }),
    };
};
const serializeAws_json1_1TagFilterList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return serializeAws_json1_1TagFilter(entry, context);
    });
};
const serializeAws_json1_1TagKeyFilterList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1TagKeyListForUntag = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1TagMap = (input, context) => {
    return Object.entries(input).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: value,
        };
    }, {});
};
const serializeAws_json1_1TagResourcesInput = (input, context) => {
    return {
        ...(input.ResourceARNList != null && {
            ResourceARNList: serializeAws_json1_1ResourceARNListForTagUntag(input.ResourceARNList, context),
        }),
        ...(input.Tags != null && { Tags: serializeAws_json1_1TagMap(input.Tags, context) }),
    };
};
const serializeAws_json1_1TagValueList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1TargetIdFilterList = (input, context) => {
    return input
        .filter((e) => e != null)
        .map((entry) => {
        return entry;
    });
};
const serializeAws_json1_1UntagResourcesInput = (input, context) => {
    return {
        ...(input.ResourceARNList != null && {
            ResourceARNList: serializeAws_json1_1ResourceARNListForTagUntag(input.ResourceARNList, context),
        }),
        ...(input.TagKeys != null && { TagKeys: serializeAws_json1_1TagKeyListForUntag(input.TagKeys, context) }),
    };
};
const deserializeAws_json1_1ComplianceDetails = (output, context) => {
    return {
        ComplianceStatus: __expectBoolean(output.ComplianceStatus),
        KeysWithNoncompliantValues: output.KeysWithNoncompliantValues != null
            ? deserializeAws_json1_1TagKeyList(output.KeysWithNoncompliantValues, context)
            : undefined,
        NoncompliantKeys: output.NoncompliantKeys != null ? deserializeAws_json1_1TagKeyList(output.NoncompliantKeys, context) : undefined,
    };
};
const deserializeAws_json1_1ConcurrentModificationException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1ConstraintViolationException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1DescribeReportCreationOutput = (output, context) => {
    return {
        ErrorMessage: __expectString(output.ErrorMessage),
        S3Location: __expectString(output.S3Location),
        StartDate: __expectString(output.StartDate),
        Status: __expectString(output.Status),
    };
};
const deserializeAws_json1_1FailedResourcesMap = (output, context) => {
    return Object.entries(output).reduce((acc, [key, value]) => {
        if (value === null) {
            return acc;
        }
        return {
            ...acc,
            [key]: deserializeAws_json1_1FailureInfo(value, context),
        };
    }, {});
};
const deserializeAws_json1_1FailureInfo = (output, context) => {
    return {
        ErrorCode: __expectString(output.ErrorCode),
        ErrorMessage: __expectString(output.ErrorMessage),
        StatusCode: __expectInt32(output.StatusCode),
    };
};
const deserializeAws_json1_1GetComplianceSummaryOutput = (output, context) => {
    return {
        PaginationToken: __expectString(output.PaginationToken),
        SummaryList: output.SummaryList != null ? deserializeAws_json1_1SummaryList(output.SummaryList, context) : undefined,
    };
};
const deserializeAws_json1_1GetResourcesOutput = (output, context) => {
    return {
        PaginationToken: __expectString(output.PaginationToken),
        ResourceTagMappingList: output.ResourceTagMappingList != null
            ? deserializeAws_json1_1ResourceTagMappingList(output.ResourceTagMappingList, context)
            : undefined,
    };
};
const deserializeAws_json1_1GetTagKeysOutput = (output, context) => {
    return {
        PaginationToken: __expectString(output.PaginationToken),
        TagKeys: output.TagKeys != null ? deserializeAws_json1_1TagKeyList(output.TagKeys, context) : undefined,
    };
};
const deserializeAws_json1_1GetTagValuesOutput = (output, context) => {
    return {
        PaginationToken: __expectString(output.PaginationToken),
        TagValues: output.TagValues != null ? deserializeAws_json1_1TagValuesOutputList(output.TagValues, context) : undefined,
    };
};
const deserializeAws_json1_1InternalServiceException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1InvalidParameterException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1PaginationTokenExpiredException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1ResourceTagMapping = (output, context) => {
    return {
        ComplianceDetails: output.ComplianceDetails != null
            ? deserializeAws_json1_1ComplianceDetails(output.ComplianceDetails, context)
            : undefined,
        ResourceARN: __expectString(output.ResourceARN),
        Tags: output.Tags != null ? deserializeAws_json1_1TagList(output.Tags, context) : undefined,
    };
};
const deserializeAws_json1_1ResourceTagMappingList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1ResourceTagMapping(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1StartReportCreationOutput = (output, context) => {
    return {};
};
const deserializeAws_json1_1Summary = (output, context) => {
    return {
        LastUpdated: __expectString(output.LastUpdated),
        NonCompliantResources: __expectLong(output.NonCompliantResources),
        Region: __expectString(output.Region),
        ResourceType: __expectString(output.ResourceType),
        TargetId: __expectString(output.TargetId),
        TargetIdType: __expectString(output.TargetIdType),
    };
};
const deserializeAws_json1_1SummaryList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Summary(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1Tag = (output, context) => {
    return {
        Key: __expectString(output.Key),
        Value: __expectString(output.Value),
    };
};
const deserializeAws_json1_1TagKeyList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1TagList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_1Tag(entry, context);
    });
    return retVal;
};
const deserializeAws_json1_1TagResourcesOutput = (output, context) => {
    return {
        FailedResourcesMap: output.FailedResourcesMap != null
            ? deserializeAws_json1_1FailedResourcesMap(output.FailedResourcesMap, context)
            : undefined,
    };
};
const deserializeAws_json1_1TagValuesOutputList = (output, context) => {
    const retVal = (output || [])
        .filter((e) => e != null)
        .map((entry) => {
        if (entry === null) {
            return null;
        }
        return __expectString(entry);
    });
    return retVal;
};
const deserializeAws_json1_1ThrottledException = (output, context) => {
    return {
        Message: __expectString(output.Message),
    };
};
const deserializeAws_json1_1UntagResourcesOutput = (output, context) => {
    return {
        FailedResourcesMap: output.FailedResourcesMap != null
            ? deserializeAws_json1_1FailedResourcesMap(output.FailedResourcesMap, context)
            : undefined,
    };
};
const deserializeMetadata = (output) => ({
    httpStatusCode: output.statusCode,
    requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"],
    extendedRequestId: output.headers["x-amz-id-2"],
    cfId: output.headers["x-amz-cf-id"],
});
const collectBody = (streamBody = new Uint8Array(), context) => {
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
const collectBodyString = (streamBody, context) => collectBody(streamBody, context).then((body) => context.utf8Encoder(body));
const buildHttpRpcRequest = async (context, headers, path, resolvedHostname, body) => {
    const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
    const contents = {
        protocol,
        hostname,
        port,
        method: "POST",
        path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
        headers,
    };
    if (resolvedHostname !== undefined) {
        contents.hostname = resolvedHostname;
    }
    if (body !== undefined) {
        contents.body = body;
    }
    return new __HttpRequest(contents);
};
const parseBody = (streamBody, context) => collectBodyString(streamBody, context).then((encoded) => {
    if (encoded.length) {
        return JSON.parse(encoded);
    }
    return {};
});
const loadRestJsonErrorCode = (output, data) => {
    const findKey = (object, key) => Object.keys(object).find((k) => k.toLowerCase() === key.toLowerCase());
    const sanitizeErrorCode = (rawValue) => {
        let cleanValue = rawValue;
        if (typeof cleanValue === "number") {
            cleanValue = cleanValue.toString();
        }
        if (cleanValue.indexOf(",") >= 0) {
            cleanValue = cleanValue.split(",")[0];
        }
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    const headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
};
