import { FetchHttpHandler as RequestHandler } from "@trivikr-test/fetch-http-handler";
import { ResourceGroupsTaggingAPIClientConfig } from "./ResourceGroupsTaggingAPIClient";
/**
 * @internal
 */
export declare const getRuntimeConfig: (config: ResourceGroupsTaggingAPIClientConfig) => {
    runtime: string;
    defaultsMode: import("@trivikr-test/types").Provider<import("@trivikr-test/smithy-client").ResolvedDefaultsMode>;
    base64Decoder: import("@trivikr-test/types").Decoder;
    base64Encoder: import("@trivikr-test/types").Encoder;
    bodyLengthChecker: import("@trivikr-test/types").BodyLengthCalculator;
    credentialDefaultProvider: (input: any) => import("@trivikr-test/types").Provider<import("@trivikr-test/types").Credentials>;
    defaultUserAgentProvider: import("@trivikr-test/types").Provider<import("@trivikr-test/types").UserAgent>;
    maxAttempts: number | import("@trivikr-test/types").Provider<number>;
    region: string | import("@trivikr-test/types").Provider<any>;
    requestHandler: (import("@trivikr-test/types").RequestHandler<any, any, import("@trivikr-test/types").HttpHandlerOptions> & import("@trivikr-test/protocol-http").HttpHandler) | RequestHandler;
    retryMode: string | import("@trivikr-test/types").Provider<string>;
    sha256: import("@trivikr-test/types").HashConstructor;
    streamCollector: import("@trivikr-test/types").StreamCollector;
    useDualstackEndpoint: boolean | import("@trivikr-test/types").Provider<boolean>;
    useFipsEndpoint: boolean | import("@trivikr-test/types").Provider<boolean>;
    utf8Decoder: import("@trivikr-test/types").Decoder;
    utf8Encoder: import("@trivikr-test/types").Encoder;
    apiVersion: string;
    urlParser: import("@trivikr-test/types").UrlParser;
    disableHostPrefix: boolean;
    logger: import("@trivikr-test/types").Logger;
    serviceId: string;
    regionInfoProvider: import("@trivikr-test/types").RegionInfoProvider;
    endpoint?: string | import("@trivikr-test/types").Endpoint | import("@trivikr-test/types").Provider<import("@trivikr-test/types").Endpoint> | undefined;
    tls?: boolean | undefined;
    retryStrategy?: import("@trivikr-test/types").RetryStrategy | undefined;
    credentials?: import("@trivikr-test/types").Credentials | import("@trivikr-test/types").Provider<import("@trivikr-test/types").Credentials> | undefined;
    signer?: import("@trivikr-test/types").RequestSigner | import("@trivikr-test/types").Provider<import("@trivikr-test/types").RequestSigner> | undefined;
    signingEscapePath?: boolean | undefined;
    systemClockOffset?: number | undefined;
    signingRegion?: string | undefined;
    signerConstructor?: (new (options: import("@trivikr-test/signature-v4").SignatureV4Init & import("@trivikr-test/signature-v4").SignatureV4CryptoInit) => import("@trivikr-test/types").RequestSigner) | undefined;
    customUserAgent?: string | import("@trivikr-test/types").UserAgent | undefined;
};
