import {
  EndpointsInputConfig,
  EndpointsResolvedConfig,
  RegionInputConfig,
  RegionResolvedConfig,
} from "@trivikr-test/config-resolver";
import {
  HostHeaderInputConfig,
  HostHeaderResolvedConfig,
} from "@trivikr-test/middleware-host-header";
import {
  RetryInputConfig,
  RetryResolvedConfig,
} from "@trivikr-test/middleware-retry";
import {
  AwsAuthInputConfig,
  AwsAuthResolvedConfig,
} from "@trivikr-test/middleware-signing";
import {
  UserAgentInputConfig,
  UserAgentResolvedConfig,
} from "@trivikr-test/middleware-user-agent";
import { HttpHandler as __HttpHandler } from "@trivikr-test/protocol-http";
import {
  Client as __Client,
  DefaultsMode,
  SmithyConfiguration as __SmithyConfiguration,
  SmithyResolvedConfiguration as __SmithyResolvedConfiguration,
} from "@trivikr-test/smithy-client";
import {
  BodyLengthCalculator as __BodyLengthCalculator,
  Credentials as __Credentials,
  Decoder as __Decoder,
  Encoder as __Encoder,
  HashConstructor as __HashConstructor,
  HttpHandlerOptions as __HttpHandlerOptions,
  Logger as __Logger,
  Provider as __Provider,
  Provider,
  RegionInfoProvider,
  StreamCollector as __StreamCollector,
  UrlParser as __UrlParser,
  UserAgent as __UserAgent,
} from "@trivikr-test/types";
import {
  DescribeReportCreationCommandInput,
  DescribeReportCreationCommandOutput,
} from "./commands/DescribeReportCreationCommand";
import {
  GetComplianceSummaryCommandInput,
  GetComplianceSummaryCommandOutput,
} from "./commands/GetComplianceSummaryCommand";
import {
  GetResourcesCommandInput,
  GetResourcesCommandOutput,
} from "./commands/GetResourcesCommand";
import {
  GetTagKeysCommandInput,
  GetTagKeysCommandOutput,
} from "./commands/GetTagKeysCommand";
import {
  GetTagValuesCommandInput,
  GetTagValuesCommandOutput,
} from "./commands/GetTagValuesCommand";
import {
  StartReportCreationCommandInput,
  StartReportCreationCommandOutput,
} from "./commands/StartReportCreationCommand";
import {
  TagResourcesCommandInput,
  TagResourcesCommandOutput,
} from "./commands/TagResourcesCommand";
import {
  UntagResourcesCommandInput,
  UntagResourcesCommandOutput,
} from "./commands/UntagResourcesCommand";
export declare type ServiceInputTypes =
  | DescribeReportCreationCommandInput
  | GetComplianceSummaryCommandInput
  | GetResourcesCommandInput
  | GetTagKeysCommandInput
  | GetTagValuesCommandInput
  | StartReportCreationCommandInput
  | TagResourcesCommandInput
  | UntagResourcesCommandInput;
export declare type ServiceOutputTypes =
  | DescribeReportCreationCommandOutput
  | GetComplianceSummaryCommandOutput
  | GetResourcesCommandOutput
  | GetTagKeysCommandOutput
  | GetTagValuesCommandOutput
  | StartReportCreationCommandOutput
  | TagResourcesCommandOutput
  | UntagResourcesCommandOutput;
export interface ClientDefaults
  extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
  requestHandler?: __HttpHandler;

  sha256?: __HashConstructor;

  urlParser?: __UrlParser;

  bodyLengthChecker?: __BodyLengthCalculator;

  streamCollector?: __StreamCollector;

  base64Decoder?: __Decoder;

  base64Encoder?: __Encoder;

  utf8Decoder?: __Decoder;

  utf8Encoder?: __Encoder;

  runtime?: string;

  disableHostPrefix?: boolean;

  maxAttempts?: number | __Provider<number>;

  retryMode?: string | __Provider<string>;

  logger?: __Logger;

  useDualstackEndpoint?: boolean | __Provider<boolean>;

  useFipsEndpoint?: boolean | __Provider<boolean>;

  serviceId?: string;

  region?: string | __Provider<string>;

  credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;

  regionInfoProvider?: RegionInfoProvider;

  defaultUserAgentProvider?: Provider<__UserAgent>;

  defaultsMode?: DefaultsMode | Provider<DefaultsMode>;
}
declare type ResourceGroupsTaggingAPIClientConfigType = Partial<
  __SmithyConfiguration<__HttpHandlerOptions>
> &
  ClientDefaults &
  RegionInputConfig &
  EndpointsInputConfig &
  RetryInputConfig &
  HostHeaderInputConfig &
  AwsAuthInputConfig &
  UserAgentInputConfig;

export interface ResourceGroupsTaggingAPIClientConfig
  extends ResourceGroupsTaggingAPIClientConfigType {}
declare type ResourceGroupsTaggingAPIClientResolvedConfigType =
  __SmithyResolvedConfiguration<__HttpHandlerOptions> &
    Required<ClientDefaults> &
    RegionResolvedConfig &
    EndpointsResolvedConfig &
    RetryResolvedConfig &
    HostHeaderResolvedConfig &
    AwsAuthResolvedConfig &
    UserAgentResolvedConfig;

export interface ResourceGroupsTaggingAPIClientResolvedConfig
  extends ResourceGroupsTaggingAPIClientResolvedConfigType {}

export declare class ResourceGroupsTaggingAPIClient extends __Client<
  __HttpHandlerOptions,
  ServiceInputTypes,
  ServiceOutputTypes,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly config: ResourceGroupsTaggingAPIClientResolvedConfig;
  constructor(configuration: ResourceGroupsTaggingAPIClientConfig);

  destroy(): void;
}
export {};
