import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import {
  DescribeReportCreationInput,
  DescribeReportCreationOutput,
} from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface DescribeReportCreationCommandInput
  extends DescribeReportCreationInput {}
export interface DescribeReportCreationCommandOutput
  extends DescribeReportCreationOutput,
    __MetadataBearer {}

export declare class DescribeReportCreationCommand extends $Command<
  DescribeReportCreationCommandInput,
  DescribeReportCreationCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: DescribeReportCreationCommandInput;
  constructor(input: DescribeReportCreationCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeReportCreationCommandInput,
    DescribeReportCreationCommandOutput
  >;
  private serialize;
  private deserialize;
}
