import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import {
  GetComplianceSummaryInput,
  GetComplianceSummaryOutput,
} from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface GetComplianceSummaryCommandInput
  extends GetComplianceSummaryInput {}
export interface GetComplianceSummaryCommandOutput
  extends GetComplianceSummaryOutput,
    __MetadataBearer {}

export declare class GetComplianceSummaryCommand extends $Command<
  GetComplianceSummaryCommandInput,
  GetComplianceSummaryCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: GetComplianceSummaryCommandInput;
  constructor(input: GetComplianceSummaryCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GetComplianceSummaryCommandInput,
    GetComplianceSummaryCommandOutput
  >;
  private serialize;
  private deserialize;
}
