import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import { GetResourcesInput, GetResourcesOutput } from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface GetResourcesCommandInput extends GetResourcesInput {}
export interface GetResourcesCommandOutput
  extends GetResourcesOutput,
    __MetadataBearer {}

export declare class GetResourcesCommand extends $Command<
  GetResourcesCommandInput,
  GetResourcesCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: GetResourcesCommandInput;
  constructor(input: GetResourcesCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetResourcesCommandInput, GetResourcesCommandOutput>;
  private serialize;
  private deserialize;
}
