import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import { GetTagKeysInput, GetTagKeysOutput } from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface GetTagKeysCommandInput extends GetTagKeysInput {}
export interface GetTagKeysCommandOutput
  extends GetTagKeysOutput,
    __MetadataBearer {}

export declare class GetTagKeysCommand extends $Command<
  GetTagKeysCommandInput,
  GetTagKeysCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: GetTagKeysCommandInput;
  constructor(input: GetTagKeysCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetTagKeysCommandInput, GetTagKeysCommandOutput>;
  private serialize;
  private deserialize;
}
