import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import { GetTagValuesInput, GetTagValuesOutput } from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface GetTagValuesCommandInput extends GetTagValuesInput {}
export interface GetTagValuesCommandOutput
  extends GetTagValuesOutput,
    __MetadataBearer {}

export declare class GetTagValuesCommand extends $Command<
  GetTagValuesCommandInput,
  GetTagValuesCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: GetTagValuesCommandInput;
  constructor(input: GetTagValuesCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetTagValuesCommandInput, GetTagValuesCommandOutput>;
  private serialize;
  private deserialize;
}
