import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import { TagResourcesInput, TagResourcesOutput } from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface TagResourcesCommandInput extends TagResourcesInput {}
export interface TagResourcesCommandOutput
  extends TagResourcesOutput,
    __MetadataBearer {}

export declare class TagResourcesCommand extends $Command<
  TagResourcesCommandInput,
  TagResourcesCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: TagResourcesCommandInput;
  constructor(input: TagResourcesCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<TagResourcesCommandInput, TagResourcesCommandOutput>;
  private serialize;
  private deserialize;
}
