import { Command as $Command } from "@trivikr-test/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@trivikr-test/types";
import { UntagResourcesInput, UntagResourcesOutput } from "../models/models_0";
import {
  ResourceGroupsTaggingAPIClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ResourceGroupsTaggingAPIClient";
export interface UntagResourcesCommandInput extends UntagResourcesInput {}
export interface UntagResourcesCommandOutput
  extends UntagResourcesOutput,
    __MetadataBearer {}

export declare class UntagResourcesCommand extends $Command<
  UntagResourcesCommandInput,
  UntagResourcesCommandOutput,
  ResourceGroupsTaggingAPIClientResolvedConfig
> {
  readonly input: UntagResourcesCommandInput;
  constructor(input: UntagResourcesCommandInput);

  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ResourceGroupsTaggingAPIClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<UntagResourcesCommandInput, UntagResourcesCommandOutput>;
  private serialize;
  private deserialize;
}
