import { ResourceGroupsTaggingAPIClientConfig } from "./ResourceGroupsTaggingAPIClient";

export declare const getRuntimeConfig: (
  config: ResourceGroupsTaggingAPIClientConfig
) => {
  runtime: string;
  sha256: import("@trivikr-test/types").HashConstructor;
  requestHandler:
    | (import("@trivikr-test/types").RequestHandler<
        any,
        any,
        import("@trivikr-test/types").HttpHandlerOptions
      > &
        import("@trivikr-test/protocol-http").HttpHandler)
    | import("@trivikr-test/fetch-http-handler").FetchHttpHandler;
  apiVersion: string;
  urlParser: import("@trivikr-test/types").UrlParser;
  bodyLengthChecker: import("@trivikr-test/types").BodyLengthCalculator;
  streamCollector: import("@trivikr-test/types").StreamCollector;
  base64Decoder: import("@trivikr-test/types").Decoder;
  base64Encoder: import("@trivikr-test/types").Encoder;
  utf8Decoder: import("@trivikr-test/types").Decoder;
  utf8Encoder: import("@trivikr-test/types").Encoder;
  disableHostPrefix: boolean;
  maxAttempts: number | import("@trivikr-test/types").Provider<number>;
  retryMode: string | import("@trivikr-test/types").Provider<string>;
  logger: import("@trivikr-test/types").Logger;
  useDualstackEndpoint:
    | boolean
    | import("@trivikr-test/types").Provider<boolean>;
  useFipsEndpoint: boolean | import("@trivikr-test/types").Provider<boolean>;
  serviceId: string;
  region: string | import("@trivikr-test/types").Provider<any>;
  credentialDefaultProvider: (
    input: any
  ) => import("@trivikr-test/types").Provider<
    import("@trivikr-test/types").Credentials
  >;
  regionInfoProvider: import("@trivikr-test/types").RegionInfoProvider;
  defaultUserAgentProvider: import("@trivikr-test/types").Provider<
    import("@trivikr-test/types").UserAgent
  >;
  defaultsMode:
    | import("@trivikr-test/smithy-client").DefaultsMode
    | import("@trivikr-test/types").Provider<
        import("@trivikr-test/smithy-client").DefaultsMode
      >;
  endpoint?:
    | string
    | import("@trivikr-test/types").Endpoint
    | import("@trivikr-test/types").Provider<
        import("@trivikr-test/types").Endpoint
      >
    | undefined;
  tls?: boolean | undefined;
  retryStrategy?: import("@trivikr-test/types").RetryStrategy | undefined;
  credentials?:
    | import("@trivikr-test/types").Credentials
    | import("@trivikr-test/types").Provider<
        import("@trivikr-test/types").Credentials
      >
    | undefined;
  signer?:
    | import("@trivikr-test/types").RequestSigner
    | import("@trivikr-test/types").Provider<
        import("@trivikr-test/types").RequestSigner
      >
    | undefined;
  signingEscapePath?: boolean | undefined;
  systemClockOffset?: number | undefined;
  signingRegion?: string | undefined;
  signerConstructor?:
    | (new (
        options: import("@trivikr-test/signature-v4").SignatureV4Init &
          import("@trivikr-test/signature-v4").SignatureV4CryptoInit
      ) => import("@trivikr-test/types").RequestSigner)
    | undefined;
  customUserAgent?:
    | string
    | import("@trivikr-test/types").UserAgent
    | undefined;
};
